#include "config.h"

const char* joy_str[]={"UP","DOWN","LEFT","RIGHT","I","II","SELECT","START","AUTOI","AUTOII"};

char set_arg(char nb_arg,char* val)
  {
     if (!val)
       {
		  #ifndef FINAL_RELEASE
         fprintf(stderr,"No value for %c arg\n",nb_arg);
        #endif
         return 1;
       };
     switch (nb_arg)
       {
              case 'v' :
                   vmode=atoi(val);
                   return 0;
              case 's' :
                   smode=atoi(val);
                   return 0;
              case 'j' :
                   nb_joy=atoi(val);
                   nb_joy=min(nb_joy,5);
                   nb_joy=max(1,nb_joy);
                   //io.joy_counter=nb_joy;
                     // nb_joy = [| 1 .. 5 |]
                   return 0;
              default:
              #ifndef FINAL_RELEASE
                   fprintf(stderr,"Unrecognized option : %c\n",nb_arg);
              #endif
                   return 1;
       }
   };

void parse_commandline(int argc,char** argv)
 {
  char next_arg,i,arg_error=0;

      next_arg=0;
      vmode=0;
      smode=-1;
      for(i=1;i<argc;i++)
        if (!next_arg)
                {
                   if (strchr(argv[i],'-'))
                     {
                      if (strlen(argv[i])==2)
                        next_arg=argv[i][1];
                      else
                        arg_error|=set_arg(argv[i][1],(char*)&argv[i][2]);
                     }
                   else
                     {
                      if (!cart_name)
                        {
                         strupr(argv[i]);
                         cart_name=argv[i];
                         {int x;
                          for (x=0;x<strlen(cart_name);x++ )
                             if (cart_name[x]=='\\')
                               cart_name[x]='/';
                          }
                         }
                      else
                        if (!bmdefault)
                          {
                           strupr(argv[i]);
                           bmdefault=argv[i];
                           }
                        else
                          {
                            //fprintf(stderr,"Unrecognised option : %s\n",argv[i]);
                            arg_error=1;
                          };
                        }
                }
              else
                {
                  arg_error|=set_arg(next_arg,argv[i]);
                  next_arg=0;
                }

      if (next_arg)
        {
          //fprintf(stderr,"No value for arg %c\n",next_arg);
          next_arg=0;
          arg_error=1;
        };
  return ;
  }

void parse_INIfile()
 {
	unsigned	char dum;
	char tmp_path[80];
   char tmp_str[10],x,y;
	unsigned	short temp_val;

   strcpy(tmp_path,short_exe_name);
   strcat(tmp_path,"HU-GO!.INI");

   set_config_file(tmp_path);

// Default value for first input
for (dum=0;dum<5;dum++ )
   {
    joy_mapping[dum][J_DOWN]=KEY_DOWN;
    joy_mapping[dum][J_UP]=KEY_UP;
    joy_mapping[dum][J_LEFT]=KEY_LEFT;
    joy_mapping[dum][J_RIGHT]=KEY_RIGHT;
    joy_mapping[dum][J_SELECT]=KEY_TAB;
    joy_mapping[dum][J_START]=KEY_ENTER;
    joy_mapping[dum][J_I]=KEY_ALT;
    joy_mapping[dum][J_II]=KEY_SPACE;
    joy_mapping[dum][J_AUTOI]=KEY_DOWN;
    joy_mapping[dum][J_AUTOII]=KEY_DOWN;
   }

   memset(tmp_str,0,10);

   for (x=1;x<=5;x++)
      {  // for each joystick
        for (y=0;y<10;y++)
           {
            strcpy(tmp_str,joy_str[y]);
            tmp_str[strlen(tmp_str)+1]=0;
            tmp_str[strlen(tmp_str)]=x+0x30;

				if ((temp_val=get_config_hex(NULL,tmp_str,0)))
				  joy_mapping[x-1][y]=temp_val;

           }
      }

   // If there, we haven't found any input related stuff

	strcpy(initial_path,get_config_string(NULL,"rom_dir","."));
	if ((initial_path[0]) && (initial_path[strlen(initial_path)-1]!='/')
		 && (initial_path[strlen(initial_path)-1]!='\\'))
	  strcat(initial_path,"/");

	language=get_config_int(NULL,"language",0);

	return ;
   }
