/***************************************************************************/
/*                                                                         */
/*				     Graphic User Interface source file								*/
/*																									*/
/*			 Most parts of this file are from me (ZEOGRAD)                    */
/*     You can use it, I trust you not to rip me but I would like to       */
/*     Be contacted if you do so and then quoted where you use this        */
/*     That's all, you can gain as much money as you want with it =)       */
/*                                                                         */
/*		 Well, all of this have been modified so much that it can be         */
/*     considered as part of the Hu-Go! project                            */
/*                                                                         */
/*             (c)1999 Zeograd (Olivier Jolly) Zeograd@caramail.com			*/
/*															  Ojolly@hotmail.com				*/
/***************************************************************************/

// Most of this is still en french, I will change this slowly...

#include "GUI.H"

char selected_rom[128];
// the buffer where the name of the rom will be placed

char initial_path[128];
// prefered path for for searching

char* tmp_buf;
// a general purpose buffer (size 100 chars)

RGB cycle[32];
// Colors to be cycled

const char * INDEX_NAME = "ROM_LIST.HG!";
// Name of the file where we keep track of the known roms

extern int frame;

int (*dummy_func)(const void *e1,const void *e2);

/*****************************************************************************

    Function:  spaces

    Description: returns a string made of spaces
    Parameters: number of spaces
    Return: a pointer to tmp_buf filled with spaces

*****************************************************************************/
char* spaces(unsigned char nb)
{
 memset(tmp_buf,' ',nb);
 tmp_buf[nb]=0;
 return tmp_buf;
 }


/*****************************************************************************

    Function:  faff

    Description:crapy function for internal use, in fact format a bit a filename
    Parameters:char* im, the raw filename
    Return:a pointer to tmp_buf, loaded with the result

*****************************************************************************/


char* faff(char im[14])
  {
char dummy[14];
strcpy(tmp_buf,"                 ");
if (!im[0])
   return tmp_buf;
else  if (!index(im,'.'))
  return strncpy(tmp_buf,im,8);
      else
        {
			int x=0,y=0;
	      while ((im[(y=x)]!='.') && (x<12))
	        dummy[x]=im[x++];
         while (x<8) dummy[x++]=' ';
	        dummy[8]='.';
         y++;
	      x++;
	      while (im[y])
           dummy[x++]=im[y++];
         dummy[x]=0;
	      return strcpy(tmp_buf,dummy);
	}
  };
/*****************************************************************************

    Function:  add_index

    Description: add info for the filename to the current index called INDEX_NAME
    Parameters:char* filename, the filename of the rom
               char* romname, the true name of the rom
               char* cur_dir, the current directory
    Return:0 if failed, 1 on success

*****************************************************************************/
int add_index(char* filename,char* romname,char* cur_dir)
{
 FILE* f;
 char* tmp_buf=(char*)alloca(100);
 INDEX_ITEM tmp_item;

 sprintf(tmp_buf,"%s/%s",cur_dir,INDEX_NAME);

 if (!(f=fopen(tmp_buf,"ab+")))
	return 0;

 memset(&tmp_item,0,sizeof(tmp_item));

 strncpy(tmp_item.filename,filename,13);

 strncpy(tmp_item.romname,romname,16);

 fwrite(&tmp_item,1,sizeof(INDEX_ITEM),f);
 fclose(f);

 return 1;
 }



/*****************************************************************************

    Function:  affiche_choix [lit. draw_choice]

    Description: draws  the current available files & dir
    Parameters: TO_DISPLAY to_display[1500] : array of struct to display
	             unsigned short dirt : index 'til there are only directories
					 unsigned choix : [choice] the index of the actual choice
					 BITMAP * background : a pointer to the background
					 BITMAP * textoutput : a pointer to the buffer where to draw text
					 unsigned short fich : [FICHier<=>file] index 'til there are files
					 unsigned short anc_choix : [ANCien Choix<=>old choice] the last
					          selected item (to do some scrolling)
    Return: AAAAAAAAAAAAAAArg! Nop', Yep guy!

*****************************************************************************/


void affichechoix(TO_DISPLAY to_display[1500],unsigned short const dirt,unsigned short const choix,
						BITMAP * background,BITMAP* textoutput,unsigned short fich,unsigned short anc_choix)
{
unsigned short dummy3,dummy2;
unsigned	basex = 0,basecenter;

clear(textoutput);

#define side_choix(cond,init)	if (choix-(choix%20)cond)		\
 {																				\
  for (dummy3=0;dummy3<=19;dummy3++)								\
    {			                                                \
	  dummy2=init;										               \
	  if (dummy2+dummy3<dirt)											\
		{																		\
	    textout(textoutput,font,to_display[dummy2+dummy3].str,basex+1,2+dummy3*10,-5);      \
	    textout(textoutput,font,to_display[dummy2+dummy3].str,basex,1+dummy3*10,-4);	       \
      }																												 \
	  else  																								          \
		 {																												 \
	     textout(textoutput,font,to_display[dummy2+dummy3].str,basex+1,2+10*dummy3,-2);	       \
        textout(textoutput,font,to_display[dummy2+dummy3].str,basex,1+10*dummy3,-3);	          \
       }																												 \
   }																													 \
  basex+=8*16;																										 \
 }


side_choix(>=20,choix-(choix%20)-20);

basecenter=basex;
for (dummy3=0;dummy3<=19;dummy3++)
    {			//{? choix - choix mod 20 + dummy 3 < dirt}
	dummy2=choix-(choix%20);
	if (dummy2+dummy3<dirt)
 	  { //dir
      textout(textoutput,font,to_display[dummy2+dummy3].str,basex+1,2+dummy3*10,-5);
	    if (choix % 20==dummy3)
		   textout(textoutput,font,to_display[dummy2+dummy3].str,basex,1+dummy3*10,-1);
	    else
		   textout(textoutput,font,to_display[dummy2+dummy3].str,basex,1+dummy3*10,-4);
	  }
	else  //file
	  {
	    textout(textoutput,font,to_display[dummy2+dummy3].str,basex+1,2+10*dummy3,-2);
        if (choix % 20==dummy3)
		    textout(textoutput,font,to_display[dummy2+dummy3].str,basex,1+10*dummy3,-1);
         else
		    textout(textoutput,font,to_display[dummy2+dummy3].str,basex,1+10*dummy3,-3);
     }
    }
basex+=8*16;


side_choix(<dirt+fich-20,choix-(choix%20)+20);
side_choix(<dirt+fich-40,choix-(choix%20)+40);

{
 char diff=anc_choix-(anc_choix%20)-choix+(choix%20);
if (diff<0)
  { //a bit of scrolling ->
	unsigned	x;
	for (x=basecenter-16*8;x<basecenter;x+=16)
		{
		vsync();
      blit(background,screen,0,0,(vwidth-background->w)/2,(vheight-background->h)/2,
        background->w,background->h);
      masked_blit(textoutput,screen,x,0,(vwidth-background->w)/2,(vheight-background->h)/2,
        background->w,background->h);
		 }
	}
if (diff>0)
  { //a bit of scrolling <-
	unsigned	x;
	for (x=basecenter+16*8;x>basecenter;x-=16)
		{
		vsync();
      blit(background,screen,0,0,(vwidth-background->w)/2,(vheight-background->h)/2,
        background->w,background->h);
      masked_blit(textoutput,screen,x,0,(vwidth-background->w)/2,(vheight-background->h)/2,
        background->w,background->h);
		 }
	}
}

vsync();
blit(background,screen,0,0,(vwidth-background->w)/2,(vheight-background->h)/2,
	    background->w,background->h);
masked_blit(textoutput,screen,basecenter,0,(vwidth-background->w)/2,(vheight-background->h)/2,
	    background->w,background->h);

}

/*****************************************************************************

    Function:  select

    Description: handle keyboard in the file selector
    Parameters: lot of! heavily derived from pascal and C can't handle imbricated funcs!
    Return: nothing but *choix may change

*****************************************************************************/


void select(char *nom_dir,
				unsigned *choix,unsigned *dirt,char fichier [1600][14],
				unsigned * fich,char* attr,
				char *ext,BITMAP* textoutput,char* must_draw,TO_DISPLAY to_display[1600])
{
int t;
static char idx_col=0, temp_col=0;
while (!keypressed())
  {
	 pause();
	 vsync();
	 temp_col=!temp_col;
	 if (temp_col) // a bit of delay
      set_color(255,&cycle[idx_col++,idx_col&=0x1F]);
	 frame++;
  }
t=readkey();

switch ( t & 0xFF )
  {
	case 13:
   case 32 : {
		if (*choix<*dirt) //change dir
		  {
			 strcat(nom_dir,"/");
		    strcat(nom_dir,fichier[to_display[*choix].corr]);
          _fixpath(nom_dir,nom_dir);
		    strupr(nom_dir);

		 {
		  unsigned dummy;
		  for (dummy=0;dummy<1600;dummy++)
		      strcpy(to_display[dummy].str,"");
       }

		 Dir(dirt,fich,nom_dir,attr,fichier,must_draw,to_display);
		 clear(textoutput);

		 *choix=0;
		}
		else //file
		 {
		   strcpy(tmp_buf,nom_dir);
		   if (strlen(nom_dir)!=3)
		     strcat(tmp_buf,"/");
		   strcat(tmp_buf,fichier[to_display[*choix].corr]);
		   strupr(tmp_buf);
		   *ext=1;
		 }
      return;
		}
	case 27 : *ext=1;
		strcpy(tmp_buf,"NO FILE");
		return;
	case 'A' ... 'Z':
   case 'a' ... 'z':
		strcpy(nom_dir," :/");
		nom_dir[0]=(char)t;
		 {
		  unsigned dummy;
		  for (dummy=0;dummy<1600;dummy++)
		      strcpy(to_display[dummy].str,"");;
       }


       Dir(dirt,fich,nom_dir,attr,fichier,must_draw,to_display);

		 clear(textoutput);
		*choix=0;
		return;
   }
switch (t)
  {
	case 0x5000:
		     if (*choix<*fich+*dirt-1)
 		       (*choix)++;
		     return;
	case 0x4800:
		     if (*choix>0)
		       (*choix)--;
		     return;
   case 0x4D00:
		     if ((*choix)+21<=(*fich)+(*dirt))
		      {
		       *choix+=20;
		       return;
		      }
		     else
            {
			    *choix=(*fich)+(*dirt)-1;
			    return;
            };
   case 0x4B00:
		     if (*choix>20)
		       *choix-=20;
		     else *choix=0;
		     return;
   case 0x4700: *choix=0;
		         return;
   case 0x4F00: *choix=*fich+*dirt-1;
		         return;
    } //1st case
}


void Dir(unsigned *dirt,unsigned *fich,char *nom_dir/*,char direct[100][14]*/,char* const attr,/*char fi[1500][14],*/char fichier [1600][14],char* must_draw,TO_DISPLAY to_display[1600])
{
  char direct[100][14];
  char fi[1500][14];
  struct ffblk DirBuf;
  unsigned i,dummy;
  char tmp_dir[80];
  FILE* f;
  INDEX_ITEM *index;
  unsigned  nb_item_in_index=0;

  *dirt=*fich=0;
  *must_draw=1;

  strcpy(tmp_dir,nom_dir);

  strcat(tmp_dir,"/*.*");
  if (findfirst( tmp_dir, &DirBuf , FA_DIREC )==0)    // Look for the first entry
    do
     {
     if ((( DirBuf.ff_attrib & 0x10) != 0) && (strcmp(DirBuf.ff_name,".")!=0))
		    {
					strcpy(direct[(*dirt)++],strupr(DirBuf.ff_name));
					direct[(*dirt)-1][13]=0;
          }
     }
    while (findnext(&DirBuf)==0);    // until there's no more

// Opening of the index
   sprintf(tmp_buf,"%s/%s",nom_dir,INDEX_NAME);
   if (!(f=fopen(tmp_buf,"rb")))
		index=NULL;
	else
	  {
		index=(INDEX_ITEM*)alloca(filesize(f));
		fread(index,1,filesize(f),f);
		nb_item_in_index=filesize(f)/sizeof(INDEX_ITEM);
		fclose(f);
		}


   strcpy(tmp_dir,nom_dir);
   strcat(tmp_dir,"/");
   strcat(tmp_dir,attr);
   if (findfirst ( tmp_dir , &DirBuf, FA_RDONLY|FA_ARCH)==0)
    do
      {
        if (( DirBuf.ff_attrib & 0x10) == 0)
			 {
	  	      strcpy(fi[(*fich)++],strupr(DirBuf.ff_name));
				fi[(*fich)-1][13]=0;
          }
      }
    while (findnext(&DirBuf)==0);

    i=0;
    if (*dirt>0)
      for (dummy=0;dummy<*dirt;dummy++)
		  {
	 	    strcpy(fichier[i],direct[dummy]);
			 to_display[i].corr=i;
			 sprintf(to_display[i++].str,"[%-8s]",direct[dummy]);
        }
    if (*fich>0)
      for (dummy=0;dummy<*fich;dummy++)
        {
			 unsigned x;
			 char index_found=0;

			 for (x=0;x<nb_item_in_index;x++)
            if (!strcmp(index[x].filename,fi[dummy]))
				 {
				  strcpy(to_display[i].str,index[x].romname);
				  index_found = 1;
				  break;
             }

 	       strcpy(fichier[i],fi[dummy]);

			 if (index_found)
				 to_display[i].corr=i++;
			 else
				{

			      unsigned CRC;
			      sprintf(tmp_buf,"%s/%s",nom_dir,fi[dummy]);
			      CRC=CRC_file(tmp_buf);

			      strcpy(to_display[i].str,faff(fi[dummy]));
			      strcat(to_display[i].str,spaces(sizeof(to_display[i].str)-strlen(to_display[i].str)));
			      to_display[i].corr=i++;

			      if (CRC!=0xFFFFFFFF)
				     {
				       unsigned x;
				       for (x=0;x<NB_ROM ; x++)
                   if (ROM_LIST[x].CRC==CRC)
						  {
						    memset(to_display[i-1].str,' ',sizeof(to_display[i-1].str));
				          strncpy(to_display[i-1].str,ROM_LIST[x].name,15);
						    to_display[i-1].str[15]=0;
						    if (strrchr(to_display[i-1].str,'-'))
							   *strrchr(to_display[i-1].str,'-')=0;
                      add_index(fichier[i-1],to_display[i-1].str,nom_dir);
                    }
                 }
               }
		  }
//    qsort(fichier,*dirt,14,strcmp);
//    qsort(&fichier[*dirt],*fich,14,strcmp);
    qsort(to_display,*dirt,sizeof(TO_DISPLAY),(typeof(dummy_func))strcmp);
    qsort(&to_display[*dirt],*fich,sizeof(TO_DISPLAY),(typeof(dummy_func))strcmp);

  }

/*****************************************************************************

    Function:  select_rom

    Description: ask the user for a rom
    Parameters: char* attr, the file mask
    Return:a pointer to selected_rom containing "NO FILE" is ESC was pushed
	                  else the full name selected

*****************************************************************************/


char* select_rom(char *attr)
 {
  char fichier[1600][14];
  TO_DISPLAY to_display[1600];
  unsigned fich,dirt;
  char nom_dir[80];
  unsigned dummy,choix,anc_choix;
  char ext,must_draw=1;
  PALETTE pal,old_pal;
  BITMAP* background;
  BITMAP* textoutput;
  char* tmp_buf2=(char*)alloca(100);

/******************************************************************/
tmp_buf=(char*)alloca(100);

sprintf(tmp_buf,"%s%s",short_exe_name,"FS_TST.TGA");
background = load_tga(tmp_buf,pal);

sprintf(tmp_buf2,"%s%s",initial_path,attr);

_fixpath(tmp_buf2,tmp_buf);
dummy=strlen(tmp_buf);
while (tmp_buf[dummy]!='/')
	dummy--;
strncpy(nom_dir,tmp_buf,dummy);
nom_dir[dummy]=0;
strupr(nom_dir);
for (ext=0;ext<16;ext++ )
   {
	 cycle[31-ext].r=cycle[ext].r=(63+(255-63)*(sin((PI*ext)/16))*(sin((PI*ext)/16)))/4;
	 cycle[31-ext].g=cycle[ext].g=(13+(255-13)*(sin((PI*ext)/16))*(sin((PI*ext)/16)))/4;
    cycle[31-ext].b=cycle[ext].b=(227+(255-227)*(sin((PI*ext)/16))*(sin((PI*ext)/16)))/4;
   }


ext=0;


text_mode(-1);
get_palette(old_pal);
set_palette(pal);
clear(screen);

(*fade_in_proc[rand()%nb_fadein])(background,(vwidth-background->w)/2,(vheight-background->h)/2,
					 background->w,background->h);

 {
  unsigned dummy;
  for (dummy=0;dummy<1600;dummy++)
      strcpy(to_display[dummy].str,"");;
 }

Dir(&dirt,&fich,nom_dir,attr,fichier,&must_draw,to_display);
textoutput = create_bitmap(512,200);
//enough for name of 20 car. without space between 2 rows

clear(textoutput);

anc_choix=choix=0;

do
  {
if ((anc_choix!=choix) || must_draw)
 affichechoix(to_display,dirt,choix,background,textoutput,fich,anc_choix);
anc_choix=choix;
must_draw=0;
select(nom_dir,&choix,&dirt,fichier,&fich,attr,&ext,textoutput,&must_draw,to_display);
  }
while (!ext);

  (*fade_out_proc[ext=rand()%nb_fadeout])((vwidth-background->w)/2,(vheight-background->h)/2,
					 background->w,background->h);
  set_palette(old_pal);
  destroy_bitmap(background);
  destroy_bitmap(textoutput);
  strcpy(selected_rom,tmp_buf);
  return selected_rom;
  }
