/*
	Portable PC-Engine Emulator
	1998 by BERO bero@geocities.co.jp

    Modified 1998 by hmmx hmmx@geocities.co.jp
    Modified 1999 by Zeograd (Olivier Jolly) zeograd@caramail.com
*/

#include	"pce.h"

byte RAM[0x8000];
// mem where variables are stocked (well, RAM... )

byte *PopRAM;
// Now dynamicaly allocated
// ( size of popRAMsize bytes )
// If someone could explain me why we need it
// the version I have works well without this trick

const PopRAMsize = 0x8000;
// I don't really know if it must be 0x8000 or 0x10000

#define	ZW	64
//byte ZBuf[ZW*256];
byte *Page[8],*ROMMap[256];
//BOOL IsROM[8];
byte *VRAM,*ROM,*vchange,*vchanges,*PCM,*WRAM,*DMYROM,*IOAREA;
// WRAM = backup RAM (~ the one on CD ROM drive)

short SPRAM[64*4];
// SPRAM = sprite RAM

unsigned long *VRAM2,*VRAMS;

int ROM_size;
// obvious, no ?
// actually, the number of block of 0x2000 bytes in the rom

extern int vmode;
// What is the favorite video mode to use
// 0 -> 256*240
// 1 -> 256*256
// 2 -> 320*200

int smode;
// what sound card type should we use? (0 means the silent one,
// my favorite : the fastest!!! ; and -1 means AUTODETECT;
// later will avoid autodetection if wanted)

char silent=1;
// a bit different from the previous one, even if asked to
// use a card, we could not be able to make sound...

unsigned char nb_joy = 1;
// number of input to poll

int Country;
// Is this^ initialised anywhere ?
// You may try to play with if some games don't want to start
// it could be useful on some cases

int IPeriod;
// Number of cycle between two interruption calls

extern int BaseClock, UPeriod;
static int TimerCount,CycleOld;
int TimerPeriod;
int scanlines_per_frame	 = 263;
int scanline;

//int MinLine = 0,MaxLine = 255;
#define	MAXDISP	227

char *cart_name;
// Name of the file containing the ROM

char short_cart_name[80];
// Just the filename without the extension (with a dot)
// you just have to add your own extension...

char short_exe_name[80];
// Used to function whatever the launching directory
// Help working under WIN9X without troubles
// Actually, the path of the EXE

char sav_path[80];
// The place where to keep saved games
// currently a subdir a the EXE path named 'SAV'

char *bmdefault=0;
// Name of the backup memory

byte cart_reload = 0;
// Once the game ended, do we need to load another rom
// i.e. do we escape game by pressing F12 or do we called the file selector

char effectively_played = 0;
// Well, the name is enough I think...

byte populus = 0;
// no more hasardous detection
// thanks to the CRC detection
// now, used to know whether the save file
// must contain extra info

int scroll = 0;

signed char snd_vol[6][32];
// cooked volume for each channel

#ifndef	ALLEGRO
#error You should implement fixed type by yourself
#else
fixed snd_inc[6],snd_pos[6]={0,0,0,0,0,0};
// how mush do we have to advance the index of each voice
// limit the use of division in sound mixing and position
#endif

unsigned freq_int=11025;
// frequency of interrupt to be used to make sound

volatile char key_delay=0;
// delay to avoid to many key strokes

volatile char can_blit=1;
// used to sync screen to 60 image/sec.

volatile unsigned message_delay=0;
// if different of zero, we must display the message pointed by pmessage

char language;
// the language of the messages
// 0 -> english
// 1 -> French, of course ;)


byte Pal[512];

IO io;
// variable containing the different port and others...

//extern char	*pCartName;

//extern char snd_bSound;

unsigned timer_60 = 0;
// how many times do the interrupt have been called

unsigned char joy_mapping[5][10];

/*static*/ int UPeriod = 0;
// Number of frame to skip

static int BaseClock;

#define	NODATA	0xff
#define	ENABLE	1
#define	DISABLE	0

#define	VDC_CR	0x01
#define	VDC_OR	0x02
#define	VDC_RR	0x04
#define	VDC_DS	0x08
#define	VDC_DV	0x10
#define	VDC_VD	0x20
#define	VDC_BSY	0x40
#define	VDC_SpHit	VDC_CR
#define	VDC_Over	VDC_OR
#define	VDC_RasHit	VDC_RR
#define	VDC_InVBlank	VDC_VD
#define	VDC_DMAfinish	VDC_DV
#define	VDC_SATBfinish	VDC_DS

#define	SATBIntON	(io.VDC[DCR].W&0x01)
#define	DMAIntON	(io.VDC[DCR].W&0x02)

#define	IRQ2	1
#define	IRQ1	2
#define	TIRQ	4

int CheckSprites(void);
int JoySticks(void);

void  IO_write(word A,byte V);
byte  IO_read(word A);
void RefreshLine(int Y1,int Y2);
void RefreshSprite(int Y1,int Y2,BYTE bg);
void RefreshScreen(void);
unsigned long CRC_file(char*);

void interrupt_60hz()
  {
   can_blit=1;
   if (key_delay)
     key_delay--;
   if (message_delay)
     message_delay--;
   timer_60++;
   return;
   };
END_OF_FUNCTION(interrupt_60hz);

/*
void interrupt_snd()
  {
   signed char t,out=0;
//   ScreenVisualBell();
//   textout(screen,font,"X",0,0,1);
   for (t=0;t<6;t++)
     {
      snd_pos[t]+=snd_inc[t];
//      if (snd_pos[t]>itofix(31))
//        snd_pos[t]-=itofix(31);
      snd_pos[t]&=31*65535+65536;
      //snd_pos[t]&=31<<16+0xFFFF;
      if (io.PSG[t][4]&0x80)
       {
	if (!(io.PSG[t][4]&0x40))
	  out+=snd_vol[t][io.wave[t][fixtoi(snd_pos[t])]];//*io.PSG[t][4]&15;
//            out+=io.wave[t][fixtoi(snd_pos[t])]*io.PSG[t][4]&15;
	else
	  out+=snd_vol[t][io.wave[t][0]];
//            out+=io.wave[t][0]*io.PSG[t][4]&15;
       }
     };
//  while ((inportb(BLASTER+0x0C) & 0x80) != 0);
//   outportb(BLASTER+0x0C, 0x10);
  // while ((inportb(BLASTER+0x0C) & 0x80) != 0);
   //outportb(BLASTER+0x0C, out);

   if (tmp_index<0x100000)
     tmp_wave[tmp_index++]=out;
   }
END_OF_FUNCTION(interrupt_snd);
*/

void bank_set(byte P,byte V)
{
#ifndef FINAL_RELEASE
	if (V>=ROM_size	&& V<0xF7) {
		fprintf(stderr,"ignore bank set %x:%02x",P,V);
		TrashMachine();
		exit(-1);
	}
#endif
	if (ROMMap[V]==IOAREA)
		Page[P]=IOAREA;
	else
		Page[P]=ROMMap[V]-P*0x2000;
//	IsROM[P] = (V < 0xF7);
}

byte _Rd6502(word A)
{
	if (Page[A>>13]!=IOAREA) return	Page[A>>13][A];
	else return IO_read(A);
}

void _Wr6502(word A,byte V)
{
	if (Page[A>>13]!=IOAREA)
	{
//void DebugDumpFp(int nMemDump, BOOL bDispStack);
//		if (A==0x2003)
//		{
//			TRACE("val=%02X\n",V);
//			DebugDumpFp(4, TRUE);
//		}
//		if (IsROM[A>>13])
//			TRACE0("Writed to ROM\n");
//		else
			Page[A>>13][A]=V;
	}
	else IO_write(A,V);
}

/* write */
	M6502 M;

void  IO_write(word A,byte V)
{
	//printf("w%04x,%02x ",A&0x3FFF,V);
  switch(A&0x1C00) {
  case 0x0000:	/* VDC */
	switch(A&3){
	case 0:	io.vdc_reg = V&31; return;
	case 1:	return;
	case 2:
		//printf("vdc_l%d,%02x ",io.vdc_reg,V);
		switch(io.vdc_reg){
		case VWR:
			/*VRAM[io.VDC[MAWR].W*2] = V;*/	io.vdc_ratch = V;
			//io.VDC_ratch[VWR] = V;
/*			if (0x1000 <= io.VDC[MAWR].W && io.VDC[MAWR].W < 0x1008)
			{
				TRACE("L: PC = %X, ", M.PC.W);
				for (int i = -10; i < 4; i++)
					TRACE("%02X ", Page[(M.PC.W+i)>>13][M.PC.W+i]);
				TRACE("\nL: V[%X] = %X\n", io.VDC[MAWR].W, V);
			}
*/			return;
		case HDR:
			io.screen_w = (V+1)*8;
			//printf("screen:%dx%d %d\n",io.screen_w,256,V);
			//TRACE("HDRl: %X\n", V);
			break;
		case MWR:
			{static	byte bgw[]={32,64,128,128};
			io.bg_h=(V&0x40)?64:32;
			io.bg_w=bgw[(V>>4)&3];}
			//TRACE("bg:%dx%d, V:%X\n",io.bg_w,io.bg_h, V);
			//TRACE("MWRl: %02X\n", V);
			break;
		case BYR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BYR].B.l	= V;
			scroll=1;
//			io.vdc_iswrite_h = 0;
//			if (scanline <= MaxLine)
//			{
				//TRACE("BYRl = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
			//if (RasHitON)
				ScrollYDiff=scanline-1;
//			}
//			else
//				ScrollYDiff=0;
			//TRACE("BYRl = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
			return;
		case BXR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BXR].B.l	= V;
			scroll=1;
			return;
			
//#define PRINT_VDC_L(REG)	case REG: TRACE(#REG "l: %X\n",V);break;
//			PRINT_VDC_L(CR);
/*			PRINT_VDC_L(HSR);
			PRINT_VDC_L(VPR);
			PRINT_VDC_L(VDW);
			PRINT_VDC_L(VCR);
			PRINT_VDC_L(SOUR);
			PRINT_VDC_L(DISTR);
			PRINT_VDC_L(DCR);*/
			
		}
		io.VDC[io.vdc_reg].B.l = V; //io.VDC_ratch[io.vdc_reg] = V;
//		if (io.vdc_reg != CR)
//			TRACE("vdc_l: %02X,%02X\n", io.vdc_reg, V);
#ifndef	FINAL_RELEASE
		if (io.vdc_reg>19) {
			fprintf(stderr,"ignore write lo vdc%d,%02x\n",io.vdc_reg,V);
		}
#endif
		return;
	case 3:
		//printf("vdc_h%d,%02x ",io.vdc_reg,V);
		switch(io.vdc_reg){
		case VWR:
			//printf("v%04x\n",io.VDC[MAWR].W);
			VRAM[io.VDC[MAWR].W*2]=io.vdc_ratch;
			VRAM[io.VDC[MAWR].W*2+1]=V;
/*			if (0x1000<=io.VDC[MAWR].W&&io.VDC[MAWR].W<0x1008)
			{
				TRACE("adr=%04X,val=%02X%02X\n", io.VDC[MAWR].W, V, io.vdc_ratch);
				//DebugDumpFp(4, TRUE);
			}
*/
/*			if (0x1000 <= io.VDC[MAWR].W && io.VDC[MAWR].W < 0x1100)
			{
				TRACE("PC = %X, ", M.PC.W);
				for (int i = -10; i < 4; i++)
					TRACE("%02X ", Page[(M.PC.W+i)>>13][M.PC.W+i]);
				TRACE("\nPage = %d", (Page[(M.PC.W)>>13] - ROM)/0x2000);
				TRACE("\nV[%X] = %02X%02X\n", io.VDC[MAWR].W, VRAM[io.VDC[MAWR].W*2+1], VRAM[io.VDC[MAWR].W*2]);
				TRACE("Page: ");
				for (i = 0; i < 8; i++)
					TRACE("%02X ", M.MPR[i]);
				TRACE("\nZero: ");
				for (i = 0; i < 32; i++)
					TRACE("%02X ", RAM[i]);
				TRACE("\n");
			}
*/			vchange[io.VDC[MAWR].W/16]=1;
			vchanges[io.VDC[MAWR].W/64]=1;
			io.VDC[MAWR].W+=io.vdc_inc;
			io.vdc_ratch=0;
			return;
		case VDW:
			//io.VDC[VDW].B.l = io.VDC_ratch[VDW];
			io.VDC[VDW].B.h	= V;
			io.screen_h = (io.VDC[VDW].W&511)+1;
			MaxLine	= io.screen_h-1;
			//TRACE("VDWh: %X\n", io.VDC[VDW].W);
			return;
		case LENR:
			//io.VDC[LENR].B.l = io.VDC_ratch[LENR];
			io.VDC[LENR].B.h = V;
			//TRACE("DMA:%04x %04x %04x\n",io.VDC[DISTR].W,io.VDC[SOUR].W,io.VDC[LENR].W);
			/* VRAM to VRAM DMA */
			memcpy(VRAM+io.VDC[DISTR].W*2,VRAM+io.VDC[SOUR].W*2,
				(io.VDC[LENR].W+1)*2);
			memset(vchange+io.VDC[DISTR].W/16,1,(io.VDC[LENR].W+1)/16);
			memset(vchange+io.VDC[DISTR].W/64,1,(io.VDC[LENR].W+1)/64);
			io.VDC[DISTR].W	+= io.VDC[LENR].W+1;
			io.VDC[SOUR].W += io.VDC[LENR].W+1;
			io.vdc_status|=VDC_DMAfinish;
			return;
		case CR	:
			{static	byte incsize[]={1,32,64,128};
			io.vdc_inc = incsize[(V>>3)&3];
			//TRACE("CRh: %02X\n", V);
			}
			break;
		case HDR:
			//io.screen_w = (io.VDC_ratch[HDR]+1)*8;
			//TRACE0("HDRh\n");
			break;
		case BYR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BYR].B.h	= V&1;
			scroll=1;
//			io.vdc_iswrite_h = 1;
//			if (scanline <= MaxLine)
//			{
				//TRACE("BYRh = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
			//if (RasHitON)
			{
				ScrollYDiff=scanline-1;
				//TRACE("BYRh = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
				//DebugDumpFp(4, TRUE);
			}
//			}
//			else
//				ScrollYDiff=0;
			//ScrollY = 51-35;
			return;
		case SATB:
			io.VDC[SATB].B.h = V;
			//TRACE("SATB=%X,scanline=%d\n", io.VDC[SATB].W, scanline);
			//memcpy(SPRAM,VRAM+io.VDC[SATB].W*2,64*8);
			io.vdc_satb=1;
			io.vdc_status&=~VDC_SATBfinish;
			return;
		case BXR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BXR].B.h	= V & 3;
			scroll=1;
//			ScrollX = io.VDC[BXR].W;
//			TRACE("BXRh = %d, scanline = %d\n", io.VDC[BXR].W, scanline);
//			io.VDC[BXR].W = 256;
			return;
			
/*#define PRINT_VDC_H(REG)	case REG: TRACE(#REG "h: %X\n",V);break;
			PRINT_VDC_H(HSR);
			PRINT_VDC_H(HDR);
			PRINT_VDC_H(VPR);
			PRINT_VDC_H(VCR);
			PRINT_VDC_H(SOUR);
			PRINT_VDC_H(DISTR);
			PRINT_VDC_H(DCR);*/
		//case RCR: TRACE("RCR: %02X%02X\n", V, io.VDC[io.vdc_reg].B.l);break;

		}
		//io.VDC[io.vdc_reg].B.l = io.VDC_ratch[io.vdc_reg];
		io.VDC[io.vdc_reg].B.h = V;
//		if (io.vdc_reg != CR)
//			TRACE("vdc_h: %02X,%02X\n", io.vdc_reg, V);
#ifndef	FINAL_RELEASE
		if (io.vdc_reg>19) {
			fprintf(stderr,"ignore write hi vdc%d,%02x\n",io.vdc_reg,V);
		}
#endif
		return;
	}
	break;

  case 0x0400:	/* VCE */
	switch(A&7) {
	case 0:	/*io.vce_reg.W = 0; io.vce_ratch=0;*/ /*??*/
		/*TRACE("VCE 0, V=%X\n", V);*/ return;
	case 2:	io.vce_reg.B.l = V; return;
	case 3:	io.vce_reg.B.h = V&1; return;
	case 4:	io.VCE[io.vce_reg.W].B.l= V;
		{
		 byte c; int i,n;
		 n = io.vce_reg.W;
		 c = io.VCE[n].W>>1;
		 if (n==0) {
			for(i=0;i<256;i+=16) Pal[i]=c;
		 }else if (n&15) Pal[n]	= c;
		}


		return;
	case 5:
		/*io.VCE[io.vce_reg.W].B.l = io.vce_ratch;*/
//	DebugDumpFp(4, TRUE);
		io.VCE[io.vce_reg.W].B.h = V;
		{
		 byte c; int i,n;
		 n = io.vce_reg.W;
		 c = io.VCE[n].W>>1;
		if (n==0) {
			for(i=0;i<256;i+=16) Pal[i]=c;
		}else if (n&15)	Pal[n] = c;
		}
		io.vce_reg.W=(io.vce_reg.W+1)&0x1FF;
		return;
	//case 6: /* ?? */ return;
	case 1:	/*TRACE("VCE 1, V=%X\n", V);*/ return;
	case 6:	/*TRACE("VCE 6, V=%X\n", V);*/ return;
	case 7:	/*TRACE("VCE 7, V=%X\n", V);*/ return;
	}
	break;

#ifdef	SOUND

  case 0x0800:	/* PSG */
/*	if (/*snd_bSound && io.psg_ch < 6)
	{
//		if (io.psg_ch==0)
//			TRACE("PSG %d,%02X\n", A&15, V);

                //int i; // a virer
		if ((A&15) <= 1)
		{
			int	i;
			for (i = 0; i < 6; i++)
				write_psg(i);
		}
		else
			write_psg(io.psg_ch);
                //for (i=0; i<6 ; fprintf(stderr,"FREQ n%d = %d\nVOL = %d\n",i,io.PSG[i][2]+io.PSG[i][3]<<8,io.PSG[i][4]&31),i++);
	}                   */

#define	BASE_FREQ 3700000
#define	ajust_vol {		     \
		  char j;	     \
		  fixed	tmp=itofix((io.PSG[io.psg_ch][4]&15)* \
		     ((io.PSG[io.psg_ch][5]&15)+(io.PSG[io.psg_ch][5]>>4))*	\
		     ((io.psg_volume&15)+(io.psg_volume>>4)))/(6*32*32),tmp2=0;  \
		  for (j=0;j<32;j++,tmp2+=tmp) \
		     snd_vol[io.psg_ch][j]=/*(signed char)(j-16)/*/fixtoi(tmp2);\
		}


  	switch(A&15){
	case 0:	io.psg_ch = V&7; return;
	case 1:	io.psg_volume =	V; return;
	case 2:	io.PSG[io.psg_ch][2] = V;
#ifdef USE_MORE_SOUND_VAR
		if ((!V) && (!io.PSG[io.psg_ch][3]))
		  snd_inc[io.psg_ch]=0;
		else
		  snd_inc[io.psg_ch]=itofix(/*1118608*/BASE_FREQ/(io.PSG[io.psg_ch][2]+io.PSG[io.psg_ch][3]*256))/freq_int;
//                  snd_inc[io.psg_ch]=itofix(io.PSG[io.psg_ch][2]+io.PSG[io.psg_ch][3]*256)/freq_int;
#endif
	     break;
	case 3:	io.PSG[io.psg_ch][3] = V&15;
#ifdef USE_MORE_SOUND_VAR
		if ((!(V&15)) && (!io.PSG[io.psg_ch][2]))
		  snd_inc[io.psg_ch]=0;
		else
		  snd_inc[io.psg_ch]=itofix(/*1118608*/BASE_FREQ/(io.PSG[io.psg_ch][2]+io.PSG[io.psg_ch][3]*256))/freq_int;
//                  snd_inc[io.psg_ch]=itofix(io.PSG[io.psg_ch][2]+io.PSG[io.psg_ch][3]*256)/freq_int;

//                snd_inc[io.psg_ch]=itofix(io.PSG[io.psg_ch][2]+io.PSG[io.psg_ch][3]<<8)/freq_int;
#endif
	     break;
	case 4:	io.PSG[io.psg_ch][4] = V;
#ifdef USE_MORE_SOUND_VAR
		ajust_vol;
#endif
	     break;
	case 5:	io.PSG[io.psg_ch][5] = V;
#ifdef USE_MORE_SOUND_VAR
		ajust_vol;
#endif
	     break;
	case 6:	if (io.PSG[io.psg_ch][4]&0x40){
				io.wave[io.psg_ch][0]=V&31;
			}else {
				io.wave[io.psg_ch][io.wavofs[io.psg_ch]]=V&31;
				io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
#ifdef USE_MORE_SOUND_VAR
				io.wave[io.psg_ch][fixtoi(snd_pos[io.psg_ch])]=V&31;
				snd_pos[io.psg_ch]=itofix((fixtoi(snd_pos[io.psg_ch])+1)&31);
#endif
			} break;
	case 7:	/*if (io.psg_ch!=5)*/
              io.PSG[io.psg_ch][7] = V;
            /*else io.PSG[5][7] = 135;*/
            break;
	case 8:	io.psg_lfo_freq	= V; break;
	case 9:	io.psg_lfo_ctrl	= V; break;
#ifndef FINAL_RELEASE
	default: fprintf(stderr,"ignored PSG write\n");
#endif
    }
    return;
#endif

  case 0x0c00:	/* timer */
	//TRACE("Timer Access: A=%X,V=%X\n", A, V);
	switch(A&1){
	case 0:	io.timer_reload	= V&127; return;
	case 1:	
		V&=1;
		if (V && !io.timer_start)
			io.timer_counter = io.timer_reload;
		io.timer_start = V;
		return;
	}
	break;

  case 0x1000:	/* joypad */
//	  TRACE("V=%02X\n", V);
		io.joy_select =	V&1;
      //io.joy_select = V;
		if (V&2) io.joy_counter	= 0;
		return;

  case 0x1400:	/* IRQ */
	switch(A&15){
	case 2:	io.irq_mask = V;/*TRACE("irq_mask = %02X\n", V);*/ return;
	case 3:	io.irq_status= (io.irq_status&~TIRQ)|(V&0xF8); return;
	}
	break;

  case 0x1800:	/* CD-ROM extention */
	switch(A&15){
	case 7:	io.backup = ENABLE; return;
/*	case 8: io.adpcm_ptr.B.l = V; return;
	case 9: io.adpcm_ptr.B.h = V; return;
	case 0xa: PCM[io.adpcm_wptr++] = V; return;
	case 0xd:
		if (V&4) io.adpcm_wptr = io.adpcm_ptr.W;
		else { io.adpcm_rptr = io.adpcm_ptr.W; io.adpcm_firstread = TRUE; }
		return;
*/	}
	break;
  }
#ifndef	FINAL_RELEASE
	fprintf(stderr,"ignore I/O write %04x,%02x\n",A,V);
#endif
//	DebugDumpTrace(4, TRUE);
}

/* read */
byte IO_read(word A)
{
	byte ret;
	//printf("r%04x ",A&0x3FFF);
  switch(A&0x1C00){
  case 0x0000: /* VDC */
  	switch(A&3){
	case 0:
		ret = io.vdc_status;
		io.vdc_status=0;//&=VDC_InVBlank;//&=~VDC_BSY;
		return ret;
	case 1:
		return 0;
	case 2:
		if (io.vdc_reg==VRR)
			return VRAM[io.VDC[MARR].W*2];
		else return io.VDC[io.vdc_reg].B.l;
	case 3:
		if (io.vdc_reg==VRR) {
			ret = VRAM[io.VDC[MARR].W*2+1];
			io.VDC[MARR].W+=io.vdc_inc;
//			TRACE0("VRAM read\n");
			return ret;
		} else return io.VDC[io.vdc_reg].B.h;
	}
	break;

  case 0x0400:/* VCE */
  	switch(A&7){
	case 4:	return io.VCE[io.vce_reg.W].B.l;
	case 5:	return io.VCE[io.vce_reg.W++].B.h;
	}
	break;
#ifdef	SOUND
  case 0x0800:	/* PSG */
	switch(A&15){
	case 0:	return io.psg_ch;
	case 1:	return io.psg_volume;
	case 2:	return io.PSG[io.psg_ch][2];
	case 3:	return io.PSG[io.psg_ch][3];
	case 4:	return io.PSG[io.psg_ch][4];
	case 5:	return io.PSG[io.psg_ch][5];
	case 6:
		{
			int	ofs=io.wavofs[io.psg_ch];
			io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
			return io.wave[io.psg_ch][ofs];

#ifdef USE_MORE_SOUND_VAR
			int ofs=fixtoi(snd_pos[io.psg_ch]);
			snd_pos[io.psg_ch]=itofix((fixtoi(snd_pos[io.psg_ch])+1)&31);
			return io.wave[io.psg_ch][ofs];
#endif

		}
	case 7:	return io.PSG[io.psg_ch][7];
	case 8:	return io.psg_lfo_freq;
	case 9:	return io.psg_lfo_ctrl;
	default: return	NODATA;
	}
	break;
#endif
  case 0x0c00:	/* timer */
	return io.timer_counter;

  case 0x1000:	/* joypad */
//	  TRACE("js=%d\n", io.joy_counter);
		ret = io.JOY[io.joy_counter]^0xff;
		if (io.joy_select&1) ret>>=4;
		else { ret&=15;	io.joy_counter=(io.joy_counter+1)%5; }
		return ret|Country; /* country 0:JPN 1<<6=US */

  case 0x1400:	/* IRQ */
	switch(A&15){
	case 2:	return io.irq_mask;
	case 3:	ret = io.irq_status;io.irq_status=0;return ret;
	}
	break;

  case 0x1800:	/* CD-ROM extention */
	switch(A&15){
	case 3:	return io.backup = DISABLE;
//	case 0xa: 
//		if (!io.adpcm_firstread) return PCM[io.adpcm_rptr++];
//		else {io.adpcm_firstread=FALSE; return NODATA;}
	}
	break;
  }
#ifndef	FINAL_RELEASE
	fprintf(stderr,"ignore I/O read %04x\n",A);
#endif
//	DebugDumpFp(4, TRUE);
	return NODATA;
}

byte Loop6502(M6502 *R)
{
	static int UCount = 0;
//	static int ACount = 0;
	static int prevline;
	int dispmin, dispmax;
	int ret;
	//printf("PC:%04x ",R->PC.W);

	dispmin	= (MaxLine-MinLine>MAXDISP ? MinLine+((MaxLine-MinLine-MAXDISP+1)>>1) :	MinLine);
	dispmax	= (MaxLine-MinLine>MAXDISP ? MaxLine-((MaxLine-MinLine-MAXDISP+1)>>1) :	MaxLine);

	scanline=(scanline+1)%scanlines_per_frame;
	//printf("scan %d\n",scanline);
	ret = INT_NONE;
	io.vdc_status&=~VDC_RasHit;
	if (scanline>MaxLine)
		io.vdc_status|=VDC_InVBlank;
//	if (scanline==MinLine+scanlines_per_frame-1)
//	else 
	if (scanline==MinLine) {
		io.vdc_status&=~VDC_InVBlank;
		prevline=dispmin;
		ScrollYDiff = 0;
		oldScrollYDiff = 0;
//		if (io.vdc_iswrite_h)
//		{
//			io.vdc_iswrite_h = 0;
//			ScrollY = io.VDC[BYR].W;
//		}
//		TRACE("\nFirstLine\n");
	}else
	if (scanline==MaxLine) {
		if (CheckSprites()) io.vdc_status|=VDC_SpHit;
		else io.vdc_status&=~VDC_SpHit;
		if (UCount) UCount--;
		else {
			if (SpriteON && SPONSwitch) RefreshSprite(prevline,dispmax,0);
			RefreshLine(prevline,dispmax-1);
			if (SpriteON && SPONSwitch) RefreshSprite(prevline,dispmax,1);
			prevline=dispmax;
			UCount=UPeriod;
			RefreshScreen();
		}
	}
	if (scanline>=MinLine && scanline<=MaxLine) {
		if (scanline==(io.VDC[RCR].W&1023)-64) {
			if (RasHitON &&	!UCount	&& dispmin<=scanline &&	scanline<=dispmax) {
				if (SpriteON &&	SPONSwitch) RefreshSprite(prevline,scanline,0);
				RefreshLine(prevline,scanline-1);
				if (SpriteON &&	SPONSwitch) RefreshSprite(prevline,scanline,1);
				prevline=scanline;
			}
			io.vdc_status|=VDC_RasHit;
			if (RasHitON) {
				//TRACE("rcr=%d\n", scanline);
				ret = INT_IRQ;
			}
		} else if (scroll) {
			if (scanline-1>prevline	&& !UCount) {
				int	tmpScrollX, tmpScrollY,	tmpScrollYDiff;
				tmpScrollX=ScrollX;
				tmpScrollY=ScrollY;
				tmpScrollYDiff=ScrollYDiff;
				ScrollX=oldScrollX;
				ScrollY=oldScrollY;
				ScrollYDiff=oldScrollYDiff;
				if (SpriteON &&	SPONSwitch) RefreshSprite(prevline,scanline-1,0);
				RefreshLine(prevline,scanline-2);
				if (SpriteON &&	SPONSwitch) RefreshSprite(prevline,scanline-1,1);
				prevline=scanline-1;
				ScrollX	= tmpScrollX;
				ScrollY	= tmpScrollY;
				ScrollYDiff = tmpScrollYDiff;
			}
		}
	} else {
		int rcr	= (io.VDC[RCR].W&1023)-64;
		if (scanline==rcr)
		{
//			ScrollYDiff = scanline;
			if (RasHitON) {
				//TRACE("rcr=%d\n", scanline);
				io.vdc_status |= VDC_RasHit;
				ret = INT_IRQ;
			}
		}
	}
	scroll=0;
	if (scanline==MaxLine+1) {
//	if (scanline==scanlines_per_frame-63) {
		//int J=Joysticks();
		//if (J&0x10000)
        //return INT_QUIT;
      if (Joysticks())
        return INT_QUIT;

		//io.JOY[0]=J;
      //io.JOY[1]=J; that's enough for 2nd player plays

		/* VRAM to SATB DMA */
		if (io.vdc_satb==1 || io.VDC[DCR].W&0x0010)
		{
			memcpy(SPRAM,VRAM+io.VDC[SATB].W*2,64*8);
			io.vdc_satb=1;
			io.vdc_status&=~VDC_SATBfinish;
		}
		if (ret==INT_IRQ)
			io.vdc_pendvsync = 1;
		else {
			//TRACE("vsync\n");
			//io.vdc_status|=VDC_InVBlank;
			if (VBlankON) {
				//TRACE("vsync=%d\n", scanline);
				ret = INT_IRQ;
			}
		}
	}
	else 
	if (scanline==min(MaxLine+5, scanlines_per_frame-1)) {
		if (io.vdc_satb) {
			io.vdc_status|=VDC_SATBfinish;
			io.vdc_satb = 0;
			if (SATBIntON) {
				//TRACE("SATB=%d\n", scanline);
				ret = INT_IRQ;
			}
/*		} else {
			io.vdc_status&=~VDC_SATBfinish;
			io.vdc_satb = 0;
*/		}
	} else if (io.vdc_pendvsync && ret!=INT_IRQ) {
		io.vdc_pendvsync = 0;
		//io.vdc_status|=VDC_InVBlank;
		if (VBlankON) {
			//TRACE("vsync=%d\n", scanline);
			ret = INT_IRQ;
		}
	}
	if (ret	== INT_IRQ) {
		if (!(io.irq_mask&IRQ1)) {
			io.irq_status|=IRQ1;
			//if (io.vdc_status&0x20)
			//TRACE("status=%02X\n", io.vdc_status);
			//TRACE("irq:scan %d\n ",scanline);
			return ret;
		}
	}
	return INT_NONE;
}

byte TimerInt(M6502 *R)
{
	if (io.timer_start) {
		io.timer_counter--;
		if (io.timer_counter > 128) {
			io.timer_counter = io.timer_reload;
			//io.irq_status &= ~TIRQ;
			if (!(io.irq_mask&TIRQ)) {
				io.irq_status |= TIRQ;
				//TRACE("tirq=%d\n",scanline);
				//TRACE("tirq\n");
				return INT_TIMER;
			}
		}
	}
	return INT_NONE;
}


#ifdef ALLEGRO
extern BITMAP* XBuf;
#else
extern byte *XBuf;
#endif

static tmp_dir_created=0;
// To know whether we got to delete temporary path
// If someone knows how to use build-in extraction then .. do it

/*****************************************************************************

    Function: CartLoad

    Description: load a card (I would like to use un unzip library here)
    Parameters: char* name (the filename to load)
    Return: -1 on error else 0

*****************************************************************************/



int CartLoad(char *name)
{
	FILE *fp;
	int fsize;
	char tmp_path[80];

	strupr(name); // Shouldn't be useful but...
        if (strstr(name,".ZIP"))
          {
           //strcpy(tmp_path,name);
           //if (strrchr(tmp_path,'\\'))
             //*(char*)strrchr(tmp_path,'\\')='\0';

//           while (i<strlen(name))
//             if (tmp_path[i++]='/')
//               tmp_path[i-1]='\\';


//           chdir(tmp_path);
           {
             char tmp_buf[128];
             sprintf(tmp_buf,"%sHU-GO!.TMP/",short_exe_name);
             mkdir(tmp_buf,0);
             tmp_dir_created=1;
           }
           //errno=0;
           //strcpy(tmp_path,get_filename(name));
            {
             char tmp_char[128],x;
             textmode(3);
             sprintf(tmp_char,"PKUNZIP %s %sHU-GO!.TMP ",name,short_exe_name);
             for (x=0;tmp_char[x] ;x++ )
                if (tmp_char[x]=='/')
                  tmp_char[x]='\\';
                system(tmp_char);
            }
//         strcpy(tmp_path,"HU-GO!.TMP/");
//         strcat(tmp_path,get_filename(name));
//         strcpy(&tmp_path[strlen(tmp_path)-4],".PCE");
           sprintf(tmp_path,"%sHU-GO!.TMP/%sPCE",short_exe_name,short_cart_name);
           fp=fopen(tmp_path,"rb");
          }
        else
	   fp=fopen(name,"rb");
	if (fp==NULL) {
	  #ifndef FINAL_RELEASE
		fprintf(stderr,"%s not found.\n",(tmp_dir_created?tmp_path:name));
	  #endif
		if (!index(name,'.')) //if dot omitted, we try with PCE extension
		  {
		    strcat(name,".PCE");
		    return CartLoad(name);
		  };

		if (strstr(name,".PCE")) //if filename with .PCE doesn't exist, it may be in ZIP
		  {
		    strcpy(&name[strlen(name)-4],".ZIP");
		    return CartLoad(name);
		   };

		return -1;
	}
	strcpy(cart_name,name);
	fseek(fp,0,SEEK_END);
	fsize =	ftell(fp);
	fseek(fp,fsize&0x1fff,SEEK_SET);
	//printf("seekptr %x",ftell(fp));
	fsize&=~0x1fff;
	ROM = (BYTE *)malloc(fsize);
	ROM_size = fsize/0x2000;
	//printf("ROM size:%x\n",fsize);
	fread(ROM,1,fsize,fp);
	fclose(fp);
/*	if (strstr(name, "populous.pce"))
	{
		fprintf(stderr,"populus\n");
		populus = 1;
	}
	else
		populus = 0; */
	return 0;
}


void ResetPCE(M6502 *M)
{
	int i;


	memset(M,0,sizeof(*M));
	memset(SPRAM,0,64*8);

	TimerCount = TimerPeriod;
	M->IPeriod = IPeriod;
	M->TrapBadOps =	1;
	memset(&io, 0, sizeof(IO));
	scanline = 0;
	io.vdc_status=0;//VDC_InVBlank;
	io.vdc_inc = 1;
	io.minline = 0;
	io.maxline = 255;
	io.irq_mask = 0;
	io.psg_volume =	0;
	io.psg_ch = 0;
	for (i = 0; i <	6; i++)
	{
		io.PSG[i][4] = 0x80;
	}
	CycleOld = 0;
	Reset6502(M);
	//printf("reset PC=%04x ",M->PC.W);
}

unsigned short NO_ROM=0xFFFF;

int InitPCE(char *name,	char *backmemname)
{
	int i=0,ROMmask;
	unsigned long CRC;
	int dummy;
   char* tmp_dummy;

//	strupr(name);
//	cart_name = name;
   if (!name)
     return -1;

   tmp_dummy=(char*)(strrchr(cart_name,'/')+1);
	while ((tmp_dummy[i]) && (short_cart_name[i++]=tmp_dummy[i])!='.') ;

   if (strlen(short_cart_name))
    if (short_cart_name[strlen(short_cart_name)-1]!='.')
     {
      short_cart_name[strlen(short_cart_name)+1]=0;
      short_cart_name[strlen(short_cart_name)]='.';
     }

   sprintf(sav_path,"%sSAV/%sSAV",short_exe_name,short_cart_name);

	if (CartLoad(name))
     return -1;

	CRC=CRC_file(name); // I'm doing it only here 'coz cartload set name

	DMYROM=(BYTE *)malloc(0x2000);
	memset(DMYROM,NODATA,0x2000);
	WRAM=(BYTE *)malloc(0x2000);
	memset(WRAM,0,0x2000);
	VRAM=(BYTE *)malloc(VRAMSIZE);
	VRAM2=(unsigned long *)malloc(VRAMSIZE);
	VRAMS=(unsigned long *)malloc(VRAMSIZE);
	//memset(VRAM,0,VRAMSIZE);
	IOAREA=(BYTE *)malloc(0x2000);
	memset(IOAREA,0xFF,0x2000);
	vchange	= (BYTE *)malloc(VRAMSIZE/32);
	memset(vchange,1,VRAMSIZE/32);
	vchanges = (BYTE *)malloc(VRAMSIZE/128);
	memset(vchanges,1,VRAMSIZE/128);

	for (dummy=0;dummy<NB_ROM;dummy++)
	  if (CRC==ROM_LIST[dummy].CRC)
	     NO_ROM=dummy;

   if (ROM_LIST[NO_ROM].flags&PINBALL_KEY)
     for (dummy=0;dummy<5;dummy++)
        {
         joy_mapping[dummy][J_II]=KEY_RSHIFT;
         joy_mapping[dummy][J_LEFT]=KEY_LSHIFT;
         joy_mapping[dummy][J_I]=KEY_STOP;
         joy_mapping[dummy][J_RIGHT]=KEY_Z;
        }


   if (ROM_LIST[NO_ROM].flags&TWO_PART_ROM)
     ROM_size=0x30;
   // Used for example with Devil Crush 512Ko

	ROMmask	= 1;
	while(ROMmask<ROM_size)	ROMmask<<=1;
	ROMmask--;
#ifndef FINAL_RELEASE
	fprintf(stderr,"ROMmask=%02X, ROM_size=%02X\n",	ROMmask, ROM_size);
#endif
	for(i=0;i<0xF7;i++)
	{
		if (ROM_size == 0x30)
		{
			switch (i&0x70)
			{
			case 0x00:
			case 0x10:
			case 0x50:
				ROMMap[i]=ROM+(i&ROMmask)*0x2000;
				break;
			case 0x20:
			case 0x60:
				ROMMap[i]=ROM+((i-0x20)&ROMmask)*0x2000;
				break;
			case 0x30:
			case 0x70:
				ROMMap[i]=ROM+((i-0x10)&ROMmask)*0x2000;
				break;
			case 0x40:
				ROMMap[i]=ROM+((i-0x20)&ROMmask)*0x2000;
				break;
			}
		}
		else
			ROMMap[i]=ROM+(i&ROMmask)*0x2000;
	}
//		ROMMap[i]=ROM+(i%ROM_size+i/ROM_size*0x10)*0x2000;
/*		if (((i&ROMmask)+i/(ROMmask+1)) < ROM_size)
			ROMMap[i]=ROM+((i&ROMmask)+i/(ROMmask+1)*0x20)*0x2000;
		else
			ROMMap[i]=ROM;
*///		ROMMap[i]=ROM+(i&ROMmask)*0x2000;
	if (NO_ROM!=0xFFFF)
     {
#ifndef FINAL_RELEASE
	    fprintf(stderr,"ROM NAME : %s\n",ROM_LIST[NO_ROM].name);
#endif
       set_message(ROM_LIST[NO_ROM].name);
       message_delay=60*5;
     }
   else
     {
       set_message(MESSAGE[language][9]);
       message_delay=60*5;
     }
	//if (populus)
	if ((NO_ROM==NO_POPULOUS1) || (NO_ROM==NO_POPULOUS2))
	{
		populus	= TRUE;
#ifndef FINAL_RELEASE
		fprintf(stderr,"POPULOUS DETECTED!!!\n");
#endif
		if (!(PopRAM=(byte*)malloc(PopRAMsize)))
		   perror("Not enough mem!");
		ROMMap[0x40] = PopRAM;
		ROMMap[0x41] = PopRAM +	0x2000;
		ROMMap[0x42] = PopRAM +	0x4000;
		ROMMap[0x43] = PopRAM +	0x6000;
	}
	else
	{
	  populus = FALSE;
	  PopRAM=NULL;
	}
/*	ROMMap[0x80] = PopRAM + (0)*0x2000;
	ROMMap[0x81] = PopRAM + (1)*0x2000;
	ROMMap[0x82] = PopRAM + (2)*0x2000;
	ROMMap[0x83] = PopRAM + (3)*0x2000;
	ROMMap[0x84] = PopRAM + (4)*0x2000;
	ROMMap[0x85] = PopRAM + (5)*0x2000;
	ROMMap[0x86] = PopRAM + (6)*0x2000;
	ROMMap[0x87] = PopRAM + (7)*0x2000;
*/	ROMMap[0xF7]=WRAM;
	ROMMap[0xF8]=RAM;
	ROMMap[0xF9]=RAM+0x2000;
	ROMMap[0xFA]=RAM+0x4000;
	ROMMap[0xFB]=RAM+0x6000;
	ROMMap[0xFF]=IOAREA; //NULL; /* NULL = I/O area */


	{
	FILE *fp;
	fp = fopen(backmemname,	"rb");
	if (fp == NULL)
		fprintf(stderr,"Can't open %s\n", backmemname);
	else
	  {
		fread(WRAM, 0x2000, 1, fp);
		fclose(fp);
	  }
	}

	return 0;
}

int RunPCE(void)
{
//	M6502 M;
	ResetPCE(&M);
//	Run6502(&M);
	Run6502();
	return 1;
}

void delete_file_tmp(char* name,int dummy,int dummy2)
 {
  delete_file(name);
  return;
 };

void TrashPCE(char *backmemname)
{
	FILE *fp;

	if (!(fp = fopen(backmemname,	"wb")))
		fprintf(stderr,"Can't open %s\n", backmemname);
	else
	{
		fwrite(WRAM, 0x2000, 1,	fp);
		fclose(fp);
	}

	if (tmp_dir_created)
	  {
	    for_each_file("HU-GO!.TMP/*.*",32,delete_file_tmp,0);
	    rmdir("HU-GO!.TMP");
	  }
	if (IOAREA) free(IOAREA);
	if (vchange) free(vchange);
	if (vchanges) free(vchanges);
	if (DMYROM) free(DMYROM);
	if (WRAM) free(WRAM);
	if (VRAM) free(VRAM);
	if (VRAM2) free(VRAM2);
	if (VRAMS) free(VRAMS);
	if (ROM) free(ROM);
	if (PopRAM) free (PopRAM);

   return ;
};

#ifdef CHRONO
unsigned nb_used[256],time_used[256];
#endif

#ifndef FINAL_RELEASE
extern int mseq(unsigned*);
extern void mseq_end();
extern void WriteBuffer_end();
extern void write_psg_end();
extern void WriteBuffer(char*,int,unsigned);
#endif

FILE * out_snd;

int main(int argc,char *argv[])
{
	char backup_mem[80];
   char _BACKUP_DAT[]="BACKUP.DAT";
	// Default name if none given
	PALETTE	P;
	char i,tmp_path[80];

   #ifdef CHRONO
	  unsigned timax=0,inst_max=0;

      for (vmode=0;vmode<256;vmode++)
	     time_used[vmode]=nb_used[vmode]=0;

   #endif

  _crt0_startup_flags|=_CRT0_FLAG_NO_LFN;
  // Disable long filename to avoid mem waste in select_rom func.

   { //First, a little trick to init random functions
	 // Unfortunately, it doesn't seem to work
  struct timeb t;
  ftime(&t);
  srandom  ((char)t.time);
  fprintf(stderr,"seed ~= %d\n",(char)t.time);
    }


    #ifdef ALLEGRO
	     allegro_init();
    #endif


	strcpy(short_exe_name,argv[0]);
	for (i=0;short_exe_name[i];i++)
	   if (short_exe_name[i]=='\\')
		short_exe_name[i]='/';

	if (strrchr(short_exe_name,'/'))
	  *(char*)(strrchr(short_exe_name,'/')+1)=0;
   // add a trailing slash


	strcpy(tmp_path,short_exe_name);
	strcat(tmp_path,"HU-GO!.TGA");

	set_gfx_mode(GFX_AUTODETECT,320,200,0,0);
	XBuf=load_tga(tmp_path,(RGB*)&P);

	set_palette(P);

   (*fade_in_proc[rand()%nb_fadein])(XBuf,0,0,320,200);
	//blit(XBuf,screen,0,0,0,0,320,200);
   // Now the logo is displayed, let's be useful instead of wait

   destroy_bitmap(XBuf);

	parse_INIfile();

	parse_commandline(argc,argv);

   if (!bmdefault)
     bmdefault=_BACKUP_DAT;

	strcpy(backup_mem,short_exe_name);
	strcat(backup_mem,bmdefault);

   sprintf(sav_path,"%sSAV/",short_exe_name);
   if (!file_exists(sav_path,FA_DIREC,0))
     mkdir(sav_path,0);
	// Create a place for saved games if not exist

   atexit(TrashSound);
   // In case of crash, try to free as many resources as we can


	getkey();
   (*fade_out_proc[rand()%nb_fadeout])(0,0,320,200);


	BaseClock = 7800000;//7160000; //3.58-21.48;
	//  7.8 Mhz  ^

	LOCK_VARIABLE(key_delay);
   LOCK_VARIABLE(timer_60);
	LOCK_VARIABLE(can_blit);
	LOCK_FUNCTION(interrupt_60hz);

	IPeriod	= BaseClock/(scanlines_per_frame*60);
#ifndef FINAL_RELEASE
	fprintf(stderr,"IPeriod = %d\n", IPeriod);
#endif
//	UPeriod = 0;
	TimerPeriod = BaseClock/1000*3*1024/21480;
#ifndef FINAL_RELEASE
	fprintf(stderr,"TimerPeriod = %d\n", TimerPeriod);
#endif

   	install_timer();
	if (!InitMachine()) return -1;

   do {
   if (!cart_name)
     cart_name=(char*)select_rom("*.pce");
   if (strcmp(cart_name,"NO FILE"))
	if (!InitPCE(cart_name, backup_mem))
     {
      effectively_played=1;
      cart_reload=0;
	 install_int_ex(interrupt_60hz,BPS_TO_TIMER(60));
		RunPCE();
	 remove_int(interrupt_60hz);

	   TrashPCE(backup_mem);
	 }
   }
   while (cart_reload);
	TrashMachine();

      #ifdef ALLEGRO
	allegro_exit();
      #endif

   if (effectively_played)
     {
      if (NO_ROM<NB_ROM)
	printf("You played %s.\nThank you very much.\nSee you soon.\n",ROM_LIST[NO_ROM].name);
      else
	printf("Unknown ROM\nIf you want to make the science progress\nPlease contact me at OJOLLY@HOTMAIL.COM ;)\nI'd be interested in having it.");
     }
   else
     printf("See Ya!\n");
      #ifdef CHRONO
	if (!(F	= fopen("RESULT.DAT","wt+")))
	  return -1;
	for (vmode=0;vmode<256;vmode++)
	  {
	   fprintf(F,"Inst 0X%02X : %10u calls, %10u (*840)ns => avr. of %10u (*840)ns\n",vmode,nb_used[vmode],time_used[vmode],(nb_used[vmode]?time_used[vmode]/nb_used[vmode]:0));
	   if (nb_used[vmode]>=timax)
	     {
	      inst_max=vmode;
	      timax=nb_used[vmode];
	      }
	  };
      fprintf(F,"\nGreat Winner is inst 0X%02X with %10u calls and %10u (*840)ns elapsed => average of %10u",inst_max,nb_used[inst_max],time_used[inst_max],time_used[inst_max]/nb_used[inst_max]);
      fclose(F);

      #endif

      if (timer_60)
	     {
         fprintf(stderr,"time elapsed : %f\n",(timer_60/60.0));
	      fprintf(stderr,"frame per sec. : %f\n",frame/(timer_60/60.0));
        }
      fclose(out_snd);
      return 0;
}
