// pce.h
#ifndef _DJGPP_INCLUDE_PCE_H
#define _DJGPP_INCLUDE_PCE_H

#define	WIDTH	(360+64)
#define	HEIGHT	256

#include <crt0.h>
#include <conio.h>
#include <sys/timeb.h>
#include <dir.h>
#include	<stdio.h>
#include	<stdlib.h>
#include "M6502.h"

#ifdef ALLEGRO

#undef VGA
// Avoid both VGA and ALLEGRO define

#define	alleg_mouse_unused
#define	alleg_joystick_unused
#define	alleg_flic_unused
#define	alleg_sound_unused
#define	alleg_gui_unused

#include <allegro.h>
#include "svgaallg.h"

#endif



typedef struct tagIO {
	pair VDC[32];
//	byte VDC_ratch[32];
	pair VCE[0x200];
	pair vce_reg;
	/* VDC */
	word vdc_inc,vdc_raster_count;
	byte vdc_reg,vdc_status,vdc_ratch,vce_ratch;
//	byte vdc_iswrite_h;
	byte vdc_satb;
	byte vdc_pendvsync;
	int bg_h,bg_w;
	int screen_w,screen_h;
	int scroll_y;
	int minline, maxline;
	/* joypad */
	byte JOY[16];
	byte joy_select,joy_counter;
	/* PSG */
	byte PSG[6][8],wave[6][32],wavofs[6];
        // PSG STRUCTURE
        // 0 : dda_out
        // 2 : freq (lo byte)  | In reality it's a divisor
        // 3 : freq (hi byte)	 | 3.7 Mhz / freq => true snd freq
        // 4 : dda_ctrl
        //     000XXXXX
        //     ^^  ^
        //     ||  ch. volume
        //     ||
        //     |direct access (everything at byte 0)
        //     |
        //    enable
        // 5 : pan (left vol = hi nibble, right vol = low nibble)
        // 7 : noise_ctrl
	byte psg_ch,psg_volume,psg_lfo_freq,psg_lfo_ctrl;
	/* TIMER */
	byte timer_reload,timer_start,timer_counter;
	/* IRQ */
	byte irq_mask,irq_status;
	/* CDROM extention */
	int backup,adpcm_firstread;
	pair adpcm_ptr;
	word adpcm_rptr,adpcm_wptr;
} IO;

void PutImage();
int CartLoad(char *name);
void ResetPCE(M6502 *M);
int InitMachine(void);
void TrashMachine(void);
int Joysticks(void);
//void set_message(char*);
void bank_set(byte P,byte V);

extern byte RAM[0x8000];
// mem where variables are stocked (well, RAM... )

extern volatile unsigned message_delay;
// if different of zero, we must display the message pointed by pmessage

extern char short_cart_name[80];
// Just the filename without the extension (with a dot)
// you just have to add your own extension...
// Will soon change because may not work if the ROM is on CD...

extern char sav_path[80];
// The place where to keep saved games
// currently a subdir a the EXE path named 'SAV'

extern byte *VRAM;

extern short SPRAM[64*4];
// SPRAM = sprite RAM

extern byte Pal[512];

extern int scanline;

extern IO io;

extern M6502 M;

extern byte populus;

extern byte *PopRAM;
// Now dynamicaly allocated
// ( size of popRAMsize bytes )
// If someone could explain me why we need it
// the version I have works well without this trick

extern const PopRAMsize;
// I don't really know if it must be 0x8000 or 0x10000

extern byte *vchange,*vchanges;
//typedef char BOOL;
//typedef unsigned char BYTE;

extern unsigned long *VRAM2,*VRAMS;

extern BITMAP* XBuf;

extern int smode;
// what sound card type should we use? (0 means the silent one,
// my favorite : the fastest!!! ; and -1 means AUTODETECT;
// later will avoid autodetection if wanted)

extern unsigned freq_int;
// frequency of interrupt to be used to make sound

extern char language;
// the current language

     #define min(a,b) \
       ({typedef _ta = (a), _tb = (b);  \
         _ta _a = (a); _tb _b = (b);     \
         _a < _b ? _a : _b; })

     #define max(a,b) \
       ({typedef _ta = (a), _tb = (b);  \
         _ta _a = (a); _tb _b = (b);     \
         _a > _b ? _a : _b; })

// Video related defines

#define	VRR	2
enum _VDC_REG {
	MAWR,MARR,VWR,vdc3,vdc4,CR,RCR,BXR,
	BYR,MWR,HSR,HDR,VPR,VDW,VCR,DCR,
	SOUR,DISTR,LENR,SATB};


#define	SpHitON		(io.VDC[CR].W&0x01)
#define	OverON		(io.VDC[CR].W&0x02)
#define	RasHitON	(io.VDC[CR].W&0x04)
#define	VBlankON	(io.VDC[CR].W&0x08)
#define	SpriteON	(io.VDC[CR].W&0x40)
#define	ScreenON	(io.VDC[CR].W&0x80)


#define	VRAMSIZE	0x20000

// Joystick related defines

#define J_UP      0
#define J_DOWN    1
#define J_LEFT    2
#define J_RIGHT   3
#define J_I       4
#define J_II      5
#define J_SELECT  6
#define J_START   7
#define J_AUTOI   8
#define J_AUTOII  9

// Post include to avoid circular definitions

#include	"list_rom.h" // List of known rom

#include "gui.h"

#include "config.h"

#include "sprite.h"

#include	</djgpp/audio/include/audio.h> // SEAL include

#ifdef SOUND
#include	"sound.h"
#endif // SOUND

#ifndef	TRUE
#define	TRUE	1
#define	FALSE	0
#endif

#endif
