#ifndef _DJGPP_INCLUDE_SPRITE_H
#define  _DJGPP_INCLUDE_SPRITE_H
#include "pce.h"

typedef	struct {
	short y,x,no,atr;
} SPR;
// Sprite structure
// y,x = pos
// no = number of the sprite (0..63  for core graphx,
//                            0..127 for super graphx (to be checked) )
// atr = attributes
// bit 0-4 : number of palette to be used
// bit 7 : background sprite
//          0 -> must be drawn behind tile patterns
//          1 -> must be drawn in front of patterns
//          (Or maybe it's the contrary ;)
// bit 8 : width
//          0 -> 16 pixels
//          1 -> 32 pixels
// bit 11 : horizontal flip
//          0 -> normal shape
//          1 -> must be draw horizontaly flipped
// bit 13-12 : heigth
//          00 -> 16 pixels
//          01 -> 32 pixels
//          10 -> 48 pixels
//          11 -> 64 pixels
// bit 15 : vertical flip
//          0 -> normal shape
//          1 -> must be drawn verticaly flipped


extern byte BGONSwitch;
// do we have to draw background ?

extern byte SPONSwitch;
// Do we have to draw sprites ?

#define	PAL(c)	R[c]
#define	SPal	(Pal+256)

#define	MinLine	io.minline
#define	MaxLine	io.maxline

//#define ScrollX	io.scroll_x
//#define ScrollY io.scroll_y
#define	ScrollX	io.VDC[BXR].W
#define	ScrollY	io.VDC[BYR].W
extern int	ScrollYDiff;
extern int	oldScrollX;
extern int	oldScrollY;
extern int	oldScrollYDiff;

extern byte SPM[WIDTH*HEIGHT];

extern int frame;
// number of frame displayed


#endif
